import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class FastInTime extends Frame
{  public double currentX, currentY; // ݂̕`ʒu
   public FastInTime()
   {  setSize(800,400);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public Complex[] FFT(Complex [] X, int Max)
   {  int m = Max; Complex[]Y = new Complex [m+1];
      for(int k = 0; k <= m; k++) Y[k] = X[k];
      // rbgt̕ёւ
      for(int j = 0; j < m; j++)
      {  int jp = j; int jx = 0; int k=1;
         while(k < m)
         { int BT = jp % 2;  jx = (jx * 2) + BT;
           jp /= 2;  k *= 2;
         }
         if(j < jx)
         {  Complex YY = Y[j]; Y[j] = Y[jx]; Y[jx] = YY; }
      }
      // FFŤvZ
      int n_half = 2; int ne = m / 2; double Pi = 6.28318530717959;
      while(ne >= 1)
      {  int n_half2 = n_half / 2;
         for(int jp = 0; jp< m; jp += n_half)
         { int jx = 0; double PM = - Pi / m ;  // IFFTƕt]Ă邱Ƃɒ
           for(int j = jp; j<= jp + n_half2 - 1; j++)
           { int jnh = j + n_half2;
             Complex yTemp = Y[jnh].mult(Complex.expJ(PM * jx)); //o^tCvZ
             Y[jnh] = Y[j].sub(yTemp); Y[j] = Y[j].add(yTemp);
             jx += ne;
           }
         }
         n_half *= 2;   ne /= 2;
      }
      Y[Max] = Y[0];
      return Y;
  }
  public Complex[] IFFT(Complex [] X, int Max)
  {
      int m = Max; Complex[]Y = new Complex [m+1];
      for(int k = 0; k <= m; k++) Y[k] = X[k];
      // rbgt̕ёւ
      for(int j = 0; j < m; j++)
      {  int jp = j; int jx = 0; int k=1;
         while(k < m)
         { int BT = jp % 2;  jx = (jx * 2) + BT;
           jp /= 2;  k *= 2;
         }
         if(j < jx)
         {  Complex YY = Y[j]; Y[j] = Y[jx]; Y[jx] = YY; }
      }
      // FFŤvZ
      int n_half = 2; int ne = m / 2; double Pi = 6.28318530717959;
      while(ne >= 1)
      {  int n_half2 = n_half / 2;
         for(int jp = 0; jp< m; jp += n_half)
         { int jx = 0; double PM = Pi / m ;  // FFTƕt]Ă邱Ƃɒ
           for(int j = jp; j<= jp + n_half2 - 1; j++)
           { int jnh = j + n_half2;
             Complex yTemp = Y[jnh].mult(Complex.expJ(PM * jx)); //o^tCvZ
             Y[jnh] = Y[j].sub(yTemp); Y[j] = Y[j].add(yTemp);
             jx += ne;
           }
         }
         n_half *= 2;   ne /= 2;
      }
      for(int k = 0; k< Max;k++)  Y[k] = Y[k].div((double) Max);
    Y[Max] = Y[0];
    return Y;
  }

   public int Xpos(double X)
   {  return (int)(X*20)+100;}
   public int Ypos(double Y)
   {  return 200- (int)(Y*40);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }

   public void paint(Graphics g)
   { 
     int Max = 64;int i,k; boolean Flag = false;
     Complex [] X = new Complex[Max + 1];
     int N1 = Max / 3; int N2 = N1 * 2;
     double DN1 = (double)N1/3;     
     for(i = 0 ; i<= Max; i++)
     {  if(i>=N1 && i<N2) X[i]= new Complex(1,0); 
        else            X[i]= new Complex(0,0); 
     }
     Complex [] Y1 = FFT(X, Max);
     Complex [] Y2 = IFFT(Y1, Max);

     setTitle("ԊԈFFT");
     g.drawString("`gFFTIFFT",100,100);
     g.drawString("FFT",310,200);
     g.drawString("IFFT",310,280);
     
     g.setColor(new Color(0,0,255));
     
     Flag = false;
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k/DN1, X[k].R, Flag);
     Flag = false;
     g.setColor(new Color(255,0,0));
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k/DN1+15, Y1[k].R/10-1, Flag);
     
     Flag = false;
     g.setColor(new Color(0,255,0));
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k/DN1, Y2[k].R-2, Flag);
    
   } 
   public static void main(String[] args)
   {  Frame w = new FastInTime();
      w.setVisible(true);
   }
}
